package com.szpg.plc.message.response.read;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;

import com.szpg.db.dao.PgHSDao;
import com.szpg.db.dao.PgHjsbblDao;
import com.szpg.db.dao.PgDeviceDao;
import com.szpg.db.dao.impl.PgHSDaoImpl;
import com.szpg.db.dao.impl.PgHjsbblDaoImpl;
import com.szpg.db.data.PgHjsbbl;
import com.szpg.db.dao.impl.PgDeviceDaoImpl;
import com.szpg.plc.message.response.ReadMemoryCommandResponse;
import com.szpg.plc.util.ByteUtil;
import com.szpg.util.Configure;
import com.szpg.util.TimeFormat;

public class ReadHSStatusCommandResponse extends ReadMemoryCommandResponse {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6523885113265769167L;

	private final Logger logger = Logger.getLogger(this.getClass().getName());
	
	private List<Boolean> hsbj; // 硫化氢浓度报警状态
	private List<Boolean> hsldbj; // 硫化氢是否联动报警
	private String[] zcList; //硫化氢监测的资产列表，从配置文件中获取

	public ReadHSStatusCommandResponse() {
		hsbj = new ArrayList<Boolean>();
		hsldbj = new ArrayList<Boolean>();
	}

	public List<Boolean> getHsbj() {
		return hsbj;
	}

	public void setHsbj(List<Boolean> hsbj) {
		this.hsbj = hsbj;
	}

	public List<Boolean> getHsldbj() {
		return hsldbj;
	}

	public void setHsldbj(List<Boolean> hsldbj) {
		this.hsldbj = hsldbj;
	}
	
	public String[] getZcList() {
		return zcList;
	}

	public void setZcList(String[] zcList) {
		this.zcList = zcList;
	}

	@Override
	public void afterAction() {
		// 1将硫化氢报警状态数据存入数据库
		PgHSDao hsalmDao = new PgHSDaoImpl();
		PgDeviceDao deviceDao = new PgDeviceDaoImpl();
		
		// 遍历资产列表，将硫化氢报警状态存入数据库
		for (int i = 0; i < zcList.length; i++) {
			String zcbh = zcList[i];
			
			int id = deviceDao.findDeviceIdByCode(zcbh);
			if (id > 0) {
				hsalmDao.addSbjzRecord(hsbj.get(i), TimeFormat.formatTimestamp(this.getTime().getTime()), id);
			}
		}
	}

	@Override
	public void parseData(byte[] messageData) {
		// 获取目标ACU的代码
		String acucode = this.getAcucode();
		
		// 判断数据的长度是否满足要求
		if (messageData.length != Integer.parseInt(Configure.getProperty("acubl", acucode + ".HSALM.WORDCOUNT")) * 2) {
			logger.error("返回的数据长度与读取的不一致！");
			this.setValid(false);
			return;
		}
		
		// 将数据转换为字符串
		// 按照高字在前，低字在后；高字节在前，低字节在后的顺序
		String dataStr = "";
		for (int c = 0; c < messageData.length; c = c + 2) {
			dataStr = ByteUtil.binToBinString(new byte[] {messageData[c], messageData[c + 1]}) + dataStr;
		}
		
		PgHjsbblDao blDao = new PgHjsbblDaoImpl();
		
		// 获取目标ACU硫化氢监测值内存区域的起始字地址
		int start = Integer.parseInt(Configure.getProperty("acubl", acucode + ".HSALM.START"));
		
		// 获取目标ACU硫化氢相关的资产列表，即硫化氢设备列表
		String zcListStr = Configure.getProperty("acubl", acucode + ".HS.ZC.LIST");
		if (StringUtils.isEmpty(zcListStr) == true) {
			this.setValid(false);
			return;
		}
		zcList = zcListStr.split(";");
		
		// 解析硫化氢浓度报警状态
		for (int i = 0; i < zcList.length; i++) {
			String zcbh = zcList[i];
			
			// 解析硫化氢浓度报警值
			PgHjsbbl almBlObj = blDao.findBlByBh(zcbh + ".AH");
			if (null == almBlObj) {
				continue;
			}
			
			int akszdz = almBlObj.getKszdz(); //开始字地址
			int aoffset = akszdz - start; //与开始字的偏移量
			int abit = almBlObj.getSzw(); //所在位
			
			char bjBt = dataStr.charAt(dataStr.length() - 1 - aoffset * 16 - abit); // 硫化氢浓度报警状态标志位
			
			// 解析硫化氢浓度报警联动标志位
			PgHjsbbl enBlObj = blDao.findBlByBh(zcbh + ".EN");
			if (null == enBlObj) {
				continue;
			}
			
			int ekszdz = enBlObj.getKszdz(); //开始字地址
			int eoffset = ekszdz - start; //与开始字的偏移量
			int ebit = enBlObj.getSzw(); //所在位
			
			char enBt = dataStr.charAt(dataStr.length() - 1 - eoffset * 16 - ebit); // 硫化氢浓度联动报警使能标志位
			
			getHsbj().add(bjBt == '1' ? true : false);
			getHsldbj().add(enBt == '1' ? true : false);
		}
	}

}
